﻿using Infragistics.Windows.DockManager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;

namespace XamDockManagerEditableHeader
{
    public class CustomContentPane : ContentPane
    {
        public CustomContentPane()
        {
            this.Closing += CustomContentPane_Closing;
            this.Closed += CustomContentPane_Closed;
            this.Loaded += CustomContentPane_Loaded;                        
        }

        private void CustomContentPane_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            XamDockManager manager = XamDockManager.GetDockManager(this);
            if (manager != null)
            {
                PaneTabItem item = Infragistics.Windows.Utilities.GetDescendantFromType<PaneTabItem>(manager, false, new Infragistics.Windows.Utilities.DependencyObjectSearchCallback<PaneTabItem>(GetPaneTabItem));

                if (item != null)
                {
                    item.MouseLeftButtonUp += Item_MouseLeftButtonUp;

                    
                }
            }
        }

        private void Text_PreviewKeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if(e.Key == Key.Enter)
            {
                this.Header = ((sender as TextBox).Text);
                this.TabHeader = ((sender as TextBox).Text);

                this.TabHeaderTemplate = null;
                this.HeaderTemplate = null;
            }
        }

        private void Item_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            if (this.IsActivePane || this.IsActiveDocument)
            {
                this.HeaderTemplate = GetEditTemplate();
                this.TabHeaderTemplate = GetEditTemplate();
            }
        }

        private void Item_PreviewMouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            if (this.IsActivePane || this.IsActiveDocument)
            {
                this.HeaderTemplate = GetEditTemplate();
                this.TabHeaderTemplate = GetEditTemplate();               
            }
        }      
        
        private void CustomContentPane_Closing(object sender, Infragistics.Windows.DockManager.Events.PaneClosingEventArgs e)
        {
            //Do Something On Close
        }

        private void CustomContentPane_Closed(object sender, Infragistics.Windows.DockManager.Events.PaneClosedEventArgs e)
        {
            //Do Something On Close
        }

        private bool GetPaneTabItem(PaneTabItem pti)
        {
            if(pti.Pane == this)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        
        private DataTemplate GetEditTemplate()
        {
            DataTemplate template = new DataTemplate();

            FrameworkElementFactory fef = new FrameworkElementFactory(typeof(TextBox));
            fef.SetBinding(TextBox.TextProperty, new Binding("."));
            fef.SetValue(TextBox.NameProperty, "EditTextbox");
            //fef.AddHandler(TextBox.LostFocusEvent, new RoutedEventHandler(Text_LostFocus));
            fef.AddHandler(TextBox.PreviewKeyDownEvent, new KeyEventHandler(Text_PreviewKeyDown));

            template.VisualTree = fef;

            return template;
        }
    }
}
